package com.example.testapk.provider;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.provider.BaseColumns;

public class TestDatabaseHelper extends SQLiteOpenHelper{
    private static final String DATABASE_NAME = "test.db";

    private static final String MEMORY_DBNAME = "temp_memory_db";

    private static final int DATABASE_VERSION = 1;

    public TestDatabaseHelper(Context context) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
    }

    public static interface Tables  {
        public static final String CONCRETE = "concrete";
        public static final String MEMORY = "memory_table";
    }

    public static interface ConcreteColumns {
        public static final String _ID = BaseColumns._ID;
        public static final String UID = "u_id";
    }

    public static interface MemoryColumns {
        public static final String _ID = BaseColumns._ID;
        public static final String CONCRETE_UID = "u_id";
        public static final String PASSWORD = "password";
    }

    private static final String CREATE_CONCRETE_TABLE =
            "CREATE TABLE " + Tables.CONCRETE + " ("
            + ConcreteColumns._ID + " INTEGER PRIMARY KEY AUTOINCREMENT, "
            + ConcreteColumns.UID + " TEXT"
            + ");";

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(CREATE_CONCRETE_TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onOpen(SQLiteDatabase db) {
        db.execSQL("ATTACH DATABASE ':memory:' AS " + MEMORY_DBNAME + ";");
        db.execSQL("CREATE TABLE IF NOT EXISTS " + MEMORY_DBNAME + "." + Tables.MEMORY + " ("
                + MemoryColumns._ID + " INTEGER PRIMARY KEY REFERENCES concrete(_id),"
                + MemoryColumns.CONCRETE_UID + " TEXT," + MemoryColumns.PASSWORD + " TEXT);");
    }
}
